#ifndef _IR_H_
#define _IR_H_

#define IR_OUT_DDR  DDRB
#define IR_OUT_PORT PORTB
#define IR_OUT_BIT  PB_IRLED

#define IR_IN_DDR DDRB
#define IR_IN_PIN PINB
#define IR_IN_BIT PB_SENSOR
#define IR_IN_PORT PORTB

#define IR_FLAG_STOP         0
#define IR_FLAG_RECEIVE_WAIT 1
#define IR_FLAG_RECEIVING    2
#define IR_FLAG_RECEIVE_END  3
#define IR_FLAG_SENDING      4
#define IR_FLAG_SEND_END     5

#define IR_RESULT_NONE     0
#define IR_RESULT_TOOSHORT 1
#define IR_RESULT_NORAM    2
#define IR_RESULT_NOROM    3
#define IR_RESULT_SUCCESS  4

// 1/(8000/8/S)*N [ms]
#define IR_TIME_LIMIT 1462

// ֳǡ¸
#define IR_SIZE (256+128-48-8)

// IR ǡǾ(Υ̤ϥΥȤߤʤ)
#define IR_DATALEN_MIN 3

// EEPROM եå
#define IR_OFFSET_SHORT_ON  0
#define IR_OFFSET_SHORT_OFF 2
#define IR_OFFSET_LONG_ON   4
#define IR_OFFSET_LONG_OFF  6
#define IR_OFFSET_SIZE      8
#define IR_OFFSET_REPEAT    10

// ¸եĿ
#define IR_FILE_NUM 8

extern volatile unsigned char ir_data[IR_SIZE];
extern volatile unsigned int ir_data_size;
extern volatile unsigned char sleepFlip;

extern volatile char ir_receiveCancelDisable;
extern volatile char ir_last_result;
extern unsigned char irregularFlag;
extern unsigned int short_on, short_off, long_on, long_off;

extern volatile unsigned char standard[2];
extern volatile unsigned char run;
extern volatile unsigned char odd;

void ir_init(void);
void ir_start_receive(unsigned char fn);
void ir_start_send(char repeat);
void ir_polling();
void ir_stop(void);
unsigned char ir_flag_status(void);
unsigned char ir_save(unsigned char fn);
unsigned char ir_load(unsigned char fn);
void ir_delete(unsigned char fn);
void write_8bit(void);
unsigned int expandRead(unsigned char** p);

#endif
